<script lang="ts">
import { defineComponent } from 'vue';

export const sizesConfig = ['xs', 's'];

export default defineComponent({
  name: 'JCheckbox',
  props: {
    active: {
      type: Boolean,
      default: false,
    },
    size: {
      type: String,
      default: 'xs',
      validator: (value: string): boolean => sizesConfig.includes(value),
    },
  },
});
</script>

<template>
  <slot />

  <div
    class="j-checkbox"
    :class="[{ active }, size]"
  >
    <div class="j-checkbox-icon-wrapper">
      <input
        type="checkbox"
        class="checkbox-input"
      />

      <div class="checkbox-background">
        <svg
          focusable="false"
          viewBox="0 0 24 24"
          aria-hidden="true"
          class="j-checkmark"
        >
          <path
            fill="none"
            d="M1.73,12.91 8.1,19.28 22.79,4.59"
            class="j-checkmark-path"
          ></path>
        </svg>
      </div>
    </div>

    <label
      class="checkbox-label"
    >
      <slot name="label" />
    </label>
  </div>
</template>

<style lang="scss" scoped>
// TODO: add styles to variable!

.j-checkbox {
  display: flex;
  align-items: center;
  cursor: pointer;

  &.active {
    .j-checkbox-icon-wrapper {
      border-color: rgb(var(--j-primary-color));
      background-color: rgb(var(--j-primary-color));
    }

    .j-checkmark-path {
      stroke-dashoffset: 0;
    }
  }
}

.xs .j-checkbox-icon-wrapper {
  width: 14px;
  height: 14px;
}

.s .j-checkbox-icon-wrapper {
  width: 18px;
  height: 18px;
}

.checkbox-input {
  opacity: 0;
  visibility: hidden;
}

.checkbox-label {
  position: relative;
  padding-left: 8px;
  cursor: pointer;
}

.j-checkbox-icon-wrapper {
  display: flex;
  justify-content: center;
  align-items: center;
  position: relative;
  border-radius: 2px;
  border: 2px rgb(var(--j-secondary-text-color)) solid;
}

.j-checkmark {
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  left: 0;
  width: 100%;
  color: white;
}

.j-checkmark-path {
  stroke: currentColor;
  stroke-width: 3.12px;
  stroke-dashoffset: 29.7833385;
  stroke-dasharray: 29.7833385;
  transition: stroke-dashoffset 180ms cubic-bezier(0.4, 0, 0.6, 1);
}
</style>
